import '../common/codable.dart';
import '../common/media_attachment.dart';
import '../common/action.dart';
import 'notificationbadge.dart';
import 'notificationbutton.dart';
import 'notificationcustomization.dart';

/// Describe NotificationContent object.
class NotificationContent extends Encodable {
  /// Text.
  String text;

  /// Title.
  String title;

  /// Template name.
  String templateName;

  /// Action.
  GetSocialAction action;

  /// Action buttons.
  List<NotificationButton> actionButtons = [];

  /// Media attachment.
  MediaAttachment mediaAttachment;

  /// Template placeholders.
  Map<String, String> templatePlaceholders = {};

  /// Customization.
  NotificationCustomization customization;

  /// Badge.
  NotificationBadge badge;

  Map<String, dynamic> toJSON() => {
        'text': text == null ? null : text,
        'title': title == null ? null : title,
        'actionButtons': actionButtons == null
            ? null
            : actionButtons.map((e) => e.toJSON()).toList(),
        'action': action == null ? null : action.toJSON(),
        'templateName': templateName == null ? null : templateName,
        'templatePlaceholders':
            templatePlaceholders == null ? null : templatePlaceholders,
        'mediaAttachment':
            mediaAttachment == null ? null : mediaAttachment.toJSON(),
        'customization': customization == null ? null : customization.toJSON(),
        'badge': badge == null ? null : badge.toJSON()
      };
}
